;Wasserzeichen
;Erzeugt aus einem Text auf einem Hintergrundbild ein Wasserzeichen mit "Profil"-Effekt.
;Bei dunklen Bildern empfiehlt sich die Verwendung einer hellen Schattenfarbe.

(define
  (script-fu-wasserzeichen
  Bild
	Hintergrund-Ebene
	Text
	Groesse
	Schriftart
	Schattenfarbe
	Schatten-Versatz
	Position
  Winkel
	Horizontalabstand
	Vertikalabstand
  )

  (let* (
  (Bild-Kopie 0)
	(Bildbreite 0)
	(Bildhoehe 0)
	(Layerbreite 0)
	(Layerhoehe 0)
	(Versatz_x 0)
	(Versatz_y 0)
	(Text-Ebene 0)
	(Schrift-Kopie-Ebene 0)
	(Bumpmap-Versatz_x 0)
	(Bumpmap-Versatz_y 0)
  (Drehwinkel 0)
	)

  (gimp-image-undo-group-start Bild)
  (gimp-selection-all Bild)
  (set! Bild-Kopie (car (gimp-image-duplicate Bild)))
  (set! Hintergrund-Ebene (car (gimp-image-flatten Bild-Kopie)))
  (set! Bildbreite (car (gimp-image-width Bild-Kopie)))
  (set! Bildhoehe (car (gimp-image-height Bild-Kopie)))
	(set! Text-Ebene (car (gimp-text-fontname Bild-Kopie -1 0 0 Text 0 TRUE Groesse PIXELS Schriftart)))
  (gimp-drawable-set-name Text-Ebene "Text")

  (set! Drehwinkel (/ (* Winkel (* 4 (atan 1.0))) 180))	
  (gimp-drawable-transform-rotate-default Text-Ebene Drehwinkel 1 0 0 0 0)
  
	(set! Layerbreite (car (gimp-drawable-width Text-Ebene)))
	(set! Layerhoehe (car (gimp-drawable-height Text-Ebene)))
	(set! Versatz_x (- Bildbreite Layerbreite))
	(set! Versatz_y (- Bildhoehe Layerhoehe))
	
  (if (= Position 0) (gimp-layer-set-offsets Text-Ebene (- Versatz_x Horizontalabstand) (- Versatz_y Vertikalabstand)))
  (if (= Position 1) (gimp-layer-set-offsets Text-Ebene (/ Versatz_x 2) (- Versatz_y Vertikalabstand)))
	(if (= Position 2) (gimp-layer-set-offsets Text-Ebene Horizontalabstand (- Versatz_y Vertikalabstand)))
  (if (= Position 3) (gimp-layer-set-offsets Text-Ebene (- Versatz_x Horizontalabstand) (/ Versatz_y 2)))
	(if (= Position 4) (gimp-layer-set-offsets Text-Ebene (/ Versatz_x 2) (/ Versatz_y 2)))
  (if (= Position 5) (gimp-layer-set-offsets Text-Ebene Horizontalabstand (/ Versatz_y 2)))
	(if (= Position 6) (gimp-layer-set-offsets Text-Ebene (- Versatz_x Horizontalabstand) Vertikalabstand))
  (if (= Position 7) (gimp-layer-set-offsets Text-Ebene (/ Versatz_x 2) Vertikalabstand))
	(if (= Position 8) (gimp-layer-set-offsets Text-Ebene Horizontalabstand Vertikalabstand))
  
  (gimp-selection-layer-alpha Text-Ebene)
	(set! Bumpmap-Versatz_x (* -1 (car(cdr(gimp-drawable-mask-bounds Hintergrund-Ebene)))))
	(set! Bumpmap-Versatz_y (* -1 (car(cddr(gimp-drawable-mask-bounds Hintergrund-Ebene)))))
	(gimp-edit-copy Hintergrund-Ebene)
	(gimp-edit-paste Text-Ebene FALSE)
  (gimp-floating-sel-to-layer (car(gimp-image-get-floating-sel Bild-Kopie)))
	(set! Schrift-Kopie-Ebene (car(gimp-image-get-active-drawable Bild-Kopie)))
	(gimp-drawable-set-name Schrift-Kopie-Ebene "Schrift-Kopie")
	
	(script-fu-drop-shadow Bild-Kopie Text-Ebene Schatten-Versatz Schatten-Versatz 6 Schattenfarbe 80 0)
	(plug-in-bump-map 1 Bild-Kopie Hintergrund-Ebene Schrift-Kopie-Ebene 135 45 3 Bumpmap-Versatz_x Bumpmap-Versatz_y 0 0 1 0 2)
	(gimp-image-remove-layer Bild-Kopie Schrift-Kopie-Ebene)
	(gimp-selection-layer-alpha Text-Ebene)
	(gimp-image-remove-layer Bild-Kopie Text-Ebene)
	(gimp-edit-cut (car(gimp-image-get-active-drawable Bild-Kopie)))
	(gimp-image-set-active-layer Bild-Kopie Hintergrund-Ebene)
	(gimp-display-new Bild-Kopie)
  (gimp-selection-none Bild-Kopie)	
  (gimp-image-clean-all Bild-Kopie)
  (gimp-image-undo-group-end Bild)
	(gimp-displays-flush Bild-Kopie)
  
  ))


(script-fu-register "script-fu-wasserzeichen"
  _"_Wasserzeichen (Text)..."
  "Erzeugt aus einem Text auf einem Hintergrundbild ein Wasserzeichen mit 'Profil'-Effekt. Bei dunklen Bildern empfiehlt sich die Verwendung einer hellen Schattenfarbe."
  "Schdefoon <software@schdefoon.de>"
  "Schdefoon.de"
  "7. August 2007"
  ""
  SF-IMAGE		"Bild"						0
  SF-DRAWABLE	"Ebene"						0
  SF-STRING		_"Text"						"© 2008 schdefoon.de"
  SF-ADJUSTMENT	_"Font size (pixels)"		'(20 2 1000 1 10 0 1)
  SF-FONT		_"Font"						"Arial Black"
  SF-COLOR		"Schattenfarbe"				'(0 0 0)
  SF-ADJUSTMENT	"Schatten-Versatz (Pixel)" 	'(3 1 1000 1 10 0 1)
  SF-OPTION		"Wasserzeichen-Position"	'("Unten rechts" "Unten mitte" "Unten links" "Mitte rechts" "Zentriert" "Mitte links" "Oben rechts" "Oben mitte" "Oben links")
  SF-ADJUSTMENT	"Drehung (Grad)" 	'(0 0 359 1 10 0 1)
  SF-ADJUSTMENT	"Horizontaler Randabstand"	'(10 0 1500 1 50 0 0)
  SF-ADJUSTMENT	"Vertikaler Randabstand"	'(10 0 1500 1 50 0 0)  
)

(script-fu-menu-register "script-fu-wasserzeichen"
			 _"<Image>/Filters/Decor")