;Wasserzeichen
;Erzeugt aus einem Logo auf einem Hintergrundbild ein Wasserzeichen mit "Profil"-Effekt.
;Bei dunklen Bildern empfiehlt sich die Verwendung einer hellen Schattenfarbe.

(define
  (script-fu-wasserzeichen_img
  Bild
	Hintergrund-Ebene
	Logo
	Logo-Breite
	Logo-Hoehe
	Position
	Schattenfarbe
	Schatten-Versatz
  Winkel
	Horizontalabstand
	Vertikalabstand
  )

  (let* (
  (Bild-Kopie 0)
	(Bildbreite 0)
	(Bildhoehe 0)
	(Logo-Bild 0)
	(Logo-Ebene 0)
	(Versatz_x 0)
	(Versatz_y 0)
	(Logo-Kopie-Ebene 0)
	(Bumpmap-Versatz_x 0)
	(Bumpmap-Versatz_y 0)
  (Drehwinkel 0)
	)

  (gimp-image-undo-group-start Bild)
  (gimp-selection-all Bild)
  (set! Bild-Kopie (car (gimp-image-duplicate Bild)))
  (set! Hintergrund-Ebene (car (gimp-image-flatten Bild-Kopie)))
  (set! Bildbreite (car (gimp-image-width Bild-Kopie)))
  (set! Bildhoehe (car (gimp-image-height Bild-Kopie)))
	(gimp-file-load 1 Logo Logo)
	(set! Logo-Bild (car (gimp-file-load 1 Logo Logo)))
  (set! Logo-Ebene (car (gimp-image-flatten Logo-Bild)))

	(set! Versatz_x (- Bildbreite Logo-Breite))
	(set! Versatz_y (- Bildhoehe Logo-Hoehe))
  (set! Drehwinkel (/ (* Winkel (* 4 (atan 1.0))) 180))

	(plug-in-photocopy 1 Logo-Bild Logo-Ebene 8 1.0 0.2 0.2)
	(gimp-image-scale Logo-Bild Logo-Breite Logo-Hoehe)
  (gimp-selection-layer-alpha Logo-Ebene)
	(gimp-edit-copy Logo-Ebene)
	(gimp-edit-paste Hintergrund-Ebene FALSE)
	
  (gimp-floating-sel-to-layer (car(gimp-image-get-floating-sel Bild-Kopie)))
	(set! Logo-Kopie-Ebene (car(gimp-image-get-active-drawable Bild-Kopie)))
	(gimp-drawable-set-name Logo-Kopie-Ebene "Logo-Kopie")

  (if (= Position 0) (gimp-layer-set-offsets Logo-Kopie-Ebene (- Versatz_x Horizontalabstand) (- Versatz_y Vertikalabstand)))
  (if (= Position 1) (gimp-layer-set-offsets Logo-Kopie-Ebene (/ Versatz_x 2) (- Versatz_y Vertikalabstand)))
	(if (= Position 2) (gimp-layer-set-offsets Logo-Kopie-Ebene Horizontalabstand (- Versatz_y Vertikalabstand)))
  (if (= Position 3) (gimp-layer-set-offsets Logo-Kopie-Ebene (- Versatz_x Horizontalabstand) (/ Versatz_y 2)))
	(if (= Position 4) (gimp-layer-set-offsets Logo-Kopie-Ebene (/ Versatz_x 2) (/ Versatz_y 2)))
  (if (= Position 5) (gimp-layer-set-offsets Logo-Kopie-Ebene Horizontalabstand (/ Versatz_y 2)))
	(if (= Position 6) (gimp-layer-set-offsets Logo-Kopie-Ebene (- Versatz_x Horizontalabstand) Vertikalabstand))
  (if (= Position 7) (gimp-layer-set-offsets Logo-Kopie-Ebene (/ Versatz_x 2) Vertikalabstand))
	(if (= Position 8) (gimp-layer-set-offsets Logo-Kopie-Ebene Horizontalabstand Vertikalabstand))
  
  (gimp-drawable-transform-rotate-default Logo-Kopie-Ebene Drehwinkel 1 0 0 0 0)
	
	(plug-in-colortoalpha 1 Bild-Kopie Logo-Kopie-Ebene '(255 255 255))
  (gimp-selection-layer-alpha Logo-Kopie-Ebene)

	(set! Bumpmap-Versatz_x (* -1 (car(cdr(gimp-drawable-mask-bounds Hintergrund-Ebene)))))
	(set! Bumpmap-Versatz_y (* -1 (car(cddr(gimp-drawable-mask-bounds Hintergrund-Ebene)))))
	(script-fu-drop-shadow Bild-Kopie Logo-Kopie-Ebene Schatten-Versatz Schatten-Versatz 6 Schattenfarbe 80 0)
	(plug-in-bump-map 1 Bild-Kopie Hintergrund-Ebene Logo-Kopie-Ebene 135 45 5 Bumpmap-Versatz_x Bumpmap-Versatz_y 0 0 1 0 2)
	(gimp-image-remove-layer Bild-Kopie Logo-Kopie-Ebene)
	(gimp-edit-cut (car(gimp-image-get-active-drawable Bild-Kopie)))
	(gimp-image-set-active-layer Bild-Kopie Hintergrund-Ebene)

	(gimp-display-new Bild-Kopie)
  (gimp-selection-none Bild-Kopie)	
  (gimp-image-clean-all Bild-Kopie)
  (gimp-image-undo-group-end Bild)
	(gimp-displays-flush Bild-Kopie)
  
  ))


(script-fu-register "script-fu-wasserzeichen_img"
  _"_Wasserzeichen (Grafik)..."
  "Erzeugt aus einem Logo auf einem Hintergrundbild ein Wasserzeichen mit 'Profil'-Effekt. Bei dunklen Bildern empfiehlt sich die Verwendung einer hellen Schattenfarbe."
  "Schdefoon <software@schdefoon.de>"
  "Schdefoon.de"
  "21. Januar 2008"
  ""
  SF-IMAGE		"Bild"								0
  SF-DRAWABLE	"Ebene"								0
  SF-FILENAME	"Wasserzeichen-Grafik"				""
  SF-ADJUSTMENT	"Gewünschte Logo-Breite in Pixel"	'(70 2 1000 1 50 0 0)
  SF-ADJUSTMENT	"Gewünschte Logo-Höhe in Pixel"	'(70 2 1000 1 50 0 0)
  SF-OPTION		"Wasserzeichen-Position"			'("Unten rechts" "Unten mitte" "Unten links" "Mitte rechts" "Zentriert" "Mitte links" "Oben rechts" "Oben mitte" "Oben links")
  SF-COLOR		"Schattenfarbe"						'(0 0 0)
  SF-ADJUSTMENT	"Schatten-Versatz (Pixel)" 			'(3 1 1000 1 50 0 1)
  SF-ADJUSTMENT	"Drehung (Grad)" 	'(0 0 359 1 10 0 1)
  SF-ADJUSTMENT	"Horizontaler Randabstand"			'(10 0 1500 1 50 0 0)
  SF-ADJUSTMENT	"Vertikaler Randabstand"			'(10 0 1500 1 50 0 0)
)

(script-fu-menu-register "script-fu-wasserzeichen_img"
			 _"<Image>/Filters/Decor")